/********************************************************/
/*  Author   .......................... Matthew Ratcliff*/
/*  Program name ...................... CIRCLE.C        */
/*  Course ............................ CSc 343, W90    */
/*  Instructor ........................ Sabharwal       */
/*  Office ............................ Rm.33, Blue Bld.*/
/*  Phone ............................. 553-5430        */
/*  Date created  ..................... 08-APR-90       */
/*  System   .......................... IBM PC/AT Compat*/
/*  Language .......................... Turbo C 2.01    */
/*  Operating system .................. MSC/DOS 3.xx    */
/*  Function .......................... Draw a circle   */
/*  using Bresenham's algorithm.                        */
/********************************************************/

/*\r* Revision History:

DD-MMM-YY By Description
--------- -- ------------------------------------------------
09-APR-90 MR Final cleanup for LAB5

*\r*/

/******************************
* Hierarchy chart for CIRCLE.C:

Use the Bresenham incremental method to draw
a circle.  Turbo C has plenty fast circle
drawing algorithms, but for the original
assignment for this CAD program, we were only
allowed to use simple line and pixel plotting
primitives in Turbo C.

- DrawCircle
>>  cpoint                


- cpoint                


*/

/* ---------- System include files -------------------- */

#include <graphics.h>

/* ---------- Module procedure prototpyes ------------- */

void cpoint( int x, int y, int xc, int yc );


/****************************************
* DrawCircle - Generate a circle using
* Bresinham's algorithm
*
* The step value should be 1 for a solid
* circle.  However, to generate a sparse
* circle use values of 2 or greater.
*
*/

void DrawCircle( int xc, int yc, int r, int color )

{ /* gen_circle begin */

int x, y, point;

x = 0;
y = r;

setcolor( color );
point = 3 - 2*r;
while (x <= y)
  {
  cpoint(x, y, xc, yc );
  if (point < 0)
    point = point + 4*x + 6;
  else
    {
    point = point + 4*(x-y) + 10;
    y--;
    }
  x++;
  } /* end while */

}



/****************************************
* Generate the 8-way symmetrical points
* on the circle.
*/

void cpoint( int x, int y, int xc, int yc )

{ /* cpoint begin */

/****************************************
* It may seem useless to use the line
* function to set a single pixel, however,
* the 'putpixel' function ignores the current
* write mode and always uses COPY_PUT.	If
* the caller wishes to draw a circle with
* XOR_PUT to implement a DRAG_CIRCLE, then
* we must use the line function to get it done.
*
*/

line(xc +  x, yc +  y,
     xc +  x, yc +  y );
line(xc +  y, yc +  x,
     xc +  y, yc +  x );
line(xc +  y, yc -  x,
     xc +  y, yc -  x );
line(xc +  x, yc -  y,
     xc +  x, yc -  y );
line(xc -  x, yc -  y,
     xc -  x, yc -  y );
line(xc -  y, yc -  x,
     xc -  y, yc -  x );
line(xc -  y, yc +  x,
     xc -  y, yc +  x );
line(xc -  x, yc +  y,
     xc -  x, yc +  y );

} /* cpoint end */

