/********************************************************************/
/* Graphics package - 512x512 grid built in memory - dump           */
/* facility will create EPSON.OUT image which can be sent           */
/* directly to the printer.                                         */
/********************************************************************/

#include <stdio.h>
#include "egraph.h"
#include "egraph.p"

/********************************************/
/* MAIN -- Graphics package test utility    */
/********************************************/

main()
{
short x,y;
uschar estat, errflag;
uschar tempstr[80];

puts("Clear screen.\n");
Cls();
puts("Color on.\n");
Color(ON);
Search( SEA );  /* Enable search mode for text placement */


puts("Horizontal grid");
for (x=0; x < GXMAX; x+=20)
  {
  Plot(x,0);
  Drawto(x,510);
  }

puts("Vertical grid");
for (y=0; y < GYMAX; y+=20)
  {
  Plot(0,y);
  Drawto(510,y);
  }


puts("X miore");
for (x=0; x < GXMAX-1; x+=64)
  {
  Plot(x,0);
  Drawto(GXMAX-x-1,GXMAX-1);
  }

puts("Y miore");
for (y=0; y < GYMAX-1; y+=64)
  {
  Plot(0,y);
  Drawto(GYMAX-1, GYMAX-1-y);
  }

Frame(0,0,GXMAX, GYMAX);

puts("Circles");

for (x=0; x<GXMAX; x+=32)
  Circle(x,x,32);

for (x=10; x <= 200; x += 40)
  Circle (255, 255, x);

puts("Strings");

for (x=0; x < 5; x ++)
  Gprint(258, 258,"This is a test");

puts("Header");

for (x=0; x<10; x++)
  {
  sprintf( tempstr, "Header Line #%d", x);
  estat = Hprint( tempstr );
  }

puts("Attempting DUMP now\n");
errflag = Dump( "EPSON.OUT" );

if (errflag == A_OK)
  puts("Dump complete; no problems.\n");
else
  puts("File error. Exit\n");

}

