/******************************
* FILES.C is a program that takes
* a file specification, wild cards or no,
* and generates a directory listing.
* To get a directory list simply
* call DirectoryList, it allocates
* storage for the file names, and
* passes you a pointer to an array
* of string pointers, which may be
* used in your directory listings.
* You may notice that it's ideally suited
* for use as a vertical menu in RadCad,
* designed this way purposfully.
*
* What follows is a test module, FTEST.C,
* used to check out the module FILES.C.
*
* To compile and link this test:
*
* tcc -w FTEST.C FILES.C
*
*/

/******************************
* Hierarchy chart for: FTEST.C:


- main                  
>> *DirectoryList             [FILES.C]
>> *FreeDirectoryList             [FILES.C]


*/

#include <stdio.h>
#include <string.h>

#include "lab.h"
#include "files.h"

void main( int argc, char **argv )
{

char path[DEFAULT_STR_SIZE];
char **fileList;
int  filecnt;
int  index;


if (argc > 1)
  {
  strcpy(path,argv[1]);
  }
else
  {
  puts("Search list for directory ? ");
  gets(path);
  }

fileList = DirectoryList( path, &filecnt );

if (filecnt > 0)
  {
  for (index=0; index<filecnt; index++)
    puts( fileList[index] );
  FreeDirectoryList();
  }

}

