/********************************************************/
/*  Author   .......................... Matthew Ratcliff*/
/*  Program name ...................... MISC.C          */
/*  Course ............................ CSc 343, W90    */
/*  Instructor ........................ Sabharwal       */
/*  Office ............................ Rm.33, Blue Bld.*/
/*  Phone ............................. 553-5430        */
/*  Date created  .....................                 */
/*  System   .......................... IBM PC/AT Compat*/
/*  Language .......................... Turbo C 2.01    */
/*  Operating system .................. MSC/DOS 3.xx    */
/*  Function .......................... Miscellaneous   */
/*  functions menu/interaction handler                  */
/********************************************************/

/*\r* Revision History:

DD-MMM-YY By Description
--------- -- ------------------------------------------------
30-MAR-90 MR Moved from LAB5.C for modularity
07-APR-90 MR Removed PASTE. Now COPY function in OBJECTS menu
08-APR-90 MR Add POINT count function. Look at total points
	     in any object.
09-APR-90 MR Final cleanup for LAB5.


*\r*/

/* ---------- System include files -------------------- */

#include <stdio.h>

/* ---------- User include files ---------------------- */

#include "lab.h"
#include "mouse.h"
#include "matrix3d.h"
#include "menu.h"
#include "spclmenu.h"
#include "objdefs.h"
#include "objops.h"
#include "RADCAD.H"               /* Access to sysinfo structure */

/* ---------- Module globals -------------------------- */

#include "miscv.h"

/* ---------- Module procedure prototpyes ------------- */


void    miscPoints( SYSINFO_TYPE *si );


/****************************************
 * Handle miscellaneous functions here
 *
 * MISC_INFO
 * MISC_SHOW
 * MISC_SPEED
 * MISC_HELP
 * MISC_DONE
 */

int        MiscHandler   ( SYSINFO_TYPE *si )

{ /* MiscHandler begin */

int exitnow;
int status;

Mshowmouse();
do
  {
  status = VertMenu( MAIN_MISC, miscMenu, miscMenuSel, BK_SAVE );
  switch( status )
    {
    case( MISC_INFO ):
      VertMenu( MAIN_MISC,
                infoMsg,
                infoMsgSel, BK_SAVE );
      break;
    case( MISC_SHOW ):
      status = VertMenu( MAIN_MISC,
                         miscShow,
                         miscShowSel, BK_SAVE );
      if (status == MISC_SHOW_COORDS)
        si->ShowMousePos = TRUE;
      else
        {
        si->ShowMousePos = FALSE;
        ReportMousePos( ERASE_MOUSE_FIELD, ERASE_MOUSE_FIELD );
        }
      break;
    case( MISC_SPEED ):
      status = VertMenu( MAIN_MISC,
                         miscSpeed,
                         miscSpeedSel, BK_SAVE );
      if (status == MISC_SPEED_NORMAL)
        {
        SetNormalMenu( TRUE );
        SetStdMenuColors( );
        }
      else if (status == MISC_SPEED_FAST)
        {
        SetNormalMenu( FALSE );
        SetStdMenuColors( );
        }
      exitnow = TRUE;
      break;

    case( MISC_POINTS ):
      if (si->TotalActiveObjects != 0)
        miscPoints( si );
      else
        noObjects("to show point count for", si->ErrorColor );
      break;

    case( MISC_HELP ):
      VertMenu( MAIN_MISC, miscHelp, miscHelpSel, BK_OVRWRITE );
      break;

    default:
      exitnow = TRUE;
      break;
    }
  }
while (exitnow == FALSE);

return( status );

} /* MiscHandler end */


/****************************************
* miscPoints handler
*
* Allow the user to select an object
* to display the number of points it
* contains.
*/


void    miscPoints( SYSINFO_TYPE *si )

{ /* miscPoints begin */

char            pointMsg[DEFAULT_STR_SIZE+1];
int             index;
OBJECT_TYPE     *obPtr;
int             button;


if (si->TotalActiveObjects == 0)
  {
  StatusLine("No Active Objects", si->ErrorColor );
  AudioError();
  }
else
  {
  do
    {
    index = SelectObject("to show point count" );
    if (index != OBJECT_NOT_SELECTED)
      {
      obPtr = si->ObjectList[index];
      if (si->ObjectSelectColor != si->ObjectColor)
        DrawObject( obPtr, si->ObjectSelectColor );
      else
        FrameObject( obPtr, TRUE);
      sprintf(pointMsg, "%d Points, LFT-continue RIT-done", obPtr->NumPts);
      StatusLine( pointMsg, si->MenuColor );
      do
        {
        button = ReadMouseButton();
        }
      while (button == NEITHER_BUTTON_PRESSED);
      if (si->ObjectSelectColor != si->ObjectColor)
        DrawObject( obPtr, si->ObjectColor );
      else
        FrameObject( obPtr, TRUE);
      if (button == RIGHT_BUTTON)
        index = OBJECT_NOT_SELECTED;
      }
    }
  while (index != OBJECT_NOT_SELECTED);

  ClearStatusLine();
  }

} /* miscPoints end */

