/* mouse.h  -- This file includes function prototypes and macro constants
 * for the functions in mouse.c. The following is a list of constants
 * that correspond to the mouse functions supported in mouse.c.
 */
#define RESET_MOUSE          	0
#define SHOW_MOUSE           	1
#define HIDE_MOUSE           	2
#define GET_MOUSE_STATUS     	3
#define SET_MOUSE_COORD      	4
#define CHECK_BUTTON_PRESS   	5
#define CHECK_BUTTON_RELEASE 	6
#define GET_MOUSE_MOVEMENT   	11
#define LEFT_BUTTON          	0    /* Use left button */
#define RIGHT_BUTTON         	1    /* Use right button */
#define EITHER_BUTTON        	2    /* Use either button */
#define CURSWIDTH            	8    /* The emulated cursor is 8 */
#define CURSHEIGHT           	8    /* pixels by 8 pixels */

/* The function prototypes for the functions in mouse.c */
void mouse(int *m1, int *m2, int *m3, int *m4);
int  resetmouse(void);
void movemouse(int x, int y);
int  initmouse(void);
void getmousecoords(int *x, int *y);
void hidemouse(void);
void showmouse(void);
void getmousemovement(int *x, int *y);
int  mousebuttonreleased(int whichbutton);
int  mousebuttonpressed(int whichbutton);
int  testbutton(int testtype, int whichbutton);
int  mouseinbox(int left, int top, int right, int bottom, int x, int y);
int  getinput(int whichbutton);
int  waitforinput(int whichbutton);
void _initcursor(void);
void _togglecursor(void);
void _drawcursor(int x, int y);
int _simulatedbuttonpressed(int whichbutton);
int _simulatedbuttonreleased(int whichbutton);
int _getkbinteraction(int whichbutton);
int _getkb(void);

