/********************************************************/
/*  Author   .......................... Matthew Ratcliff*/
/*  Program name ...................... OBJECTSV.H      */
/*  Course ............................ CSc 343, W90    */
/*  Instructor ........................ Sabharwal       */
/*  Office ............................ Rm.33, Blue Bld.*/
/*  Phone ............................. 553-5430        */
/*  Date created  ..................... 30-MAR-90       */
/*  System   .......................... IBM PC/AT Compat*/
/*  Language .......................... Turbo C 2.01    */
/*  Operating system .................. MSC/DOS 3.xx    */
/*  Function .......................... Object menu     */
/*  variables for OBJECTS.C                             */
/********************************************************/

/*\r* Revision History:

DD-MMM-YY By Description
--------- -- ------------------------------------------------
30-MAR-90 MR Moved from MENUSV.H for modularity.
07-APR-90 MR Add COPY and ANIMATE.
09-APR-90 MR Final cleanup for LAB5.

*\r*/



/* Objects menu */

char *objectsMenu[] = {
"Rotate",
"Move",
"Scale",
"3-D",
"Copy",
"Animate",
"Undo",
"Unerase",
"Cleanup",
"Redraw",
"Help",
"Done",
NULL };

char *objectsMenuSel = { "SSSSSSSSSSSS" };

enum OBJECT_MENU_SEL { OBJECT_ROTATE,
                       OBJECT_MOVE,
                       OBJECT_SCALE,
                       OBJECT_3_D,
                       OBJECT_COPY,
                       OBJECT_ANIMATE,
                       OBJECT_UNDO,
                       OBJECT_UNERASE,
                       OBJECT_CLEANUP,
                       OBJECT_REDRAW,
                       OBJECT_HELP,
                       OBJECT_DONE };

char *objectHelp[] ={
"Select object & then...",
"Rotate  - about X,Y or Z axis",
"Move    - to another position",
"Scale   - adjust object's size",
"3-D     - draw axis for it &",
" SPIN, 3D, about axis",
"Copy    - make copy of obect",
" at a new location",
"Animate - animate display",
" by flipping thru Undo history",
"Undo    - last function on it",
"Unerase - reivew erased objects",
" & selectively unerase",
"Cleanup - clean up memory",
"Redraw  - Clear display & redraw",
"        [OK]",
NULL };
char *objectCleanup[] = {
" *   Clean Up   * ",
"",
"Free backup memory...",
"      UNDO",
"      ERASE",
"  UNDO & ERASE",
"     CANCEL",
NULL };

char *objectCleanupSel = { "NNNSSSS" };

enum OBJECT_CLEANUP_SEL { CLEANUP_UNDO   = 3,
                          CLEANUP_DELETE = 4,
                          CLEANUP_ALL    = 5,
                          CLEANUP_CANCEL = 6 };

char *objectHelpSel =  NULL;


char *objectRotateMenu[] = {
"Rotate about...",
"",
"X Axis",
"Y Axis",
"Z Axis",
NULL };

char *objectRotateSel = { "NNSSS" };

enum OBJECT_ROTATE_SEL { X_ROTATE = 2,
                         Y_ROTATE = 3,
                         Z_ROTATE = 4 };


char *objectSpinMenu[] = {
"Step angle ",
"of rotation",
"Ŀ",
"Deg-Sides",
"Ĵ",
"10   36 ",
"18   20 ",
"20   18 ",
"24   15 ",
"30   12 ",
"36   10 ",
"72   5  ",
"90   4  ",
"",
NULL };

char *objectSpinMenuSel = { "NNDDDSSSSSSSSD" };

enum OBJECT_SPIN_SEL { STEP_10 = 5,
                       STEP_18 = 6,
                       STEP_20 = 7,
                       STEP_24 = 8,
                       STEP_30 = 9,
                       STEP_36 = 10,
                       STEP_72 = 11,
                       STEP_90 = 12 };

char *objectScaleMenu[] = {
"Ŀ",
"    Scale   ",
"   Options  ",
"",
"Ŀ",
"  Uniform   ",
"Differential",
"",
NULL };

char *objectScaleMenuSel = { "NNNNDSSD" };

#define UNIFORM_SCALE_REQUEST 5

char *objectGroupMenu[] = {
"Group",
"Operations",
"New Group",
"Scale",
"Transform",
"Rotate",
"Done",
NULL };

char *objectGroupSel = { "NNSSSSS" };



