/********************************************************/
/*  Author   .......................... Matthew Ratcliff*/
/*  Program name ...................... VIDEOID.H       */
/*  Course ............................ CSc 343, W90    */
/*  Instructor ........................ Sabharwal       */
/*  Office ............................ Rm.33, Blue Bld.*/
/*  Phone ............................. 553-5430        */
/*  Date created  ..................... 19-JAN-90       */
/*  System   .......................... IBM PC/AT Compat*/
/*  Language .......................... Turbo C 2.01    */
/*  Operating system .................. MSC/DOS 3.xx    */
/*  Function ..........................                 */
/*  Declaration for VideoID() assembly function.        */
/********************************************************/

/*\r* Revision History:

DD-MMM-YY By Description
--------- -- ------------------------------------------------
19-JAN-90 MR Provide access to this assembly function which
              reliably detects all available graphics adapters
              and modes in any PC system.
09-APR-90 MR Final cleanup for LAB5.


*\r*/


typedef struct VID_TYPE
  {
  unsigned char  VideoSubsystem;
  unsigned char  Display;
  } VID_TYPE;

/*------------------------------------------------------*/
/* VideoID requires a pointer to an array of two        */
/* VIDstruct, video identification structures           */
/* The first entry is for the active display, and       */
/* the second is for the alternate display, if there    */
/* is one installed.                                    */
/*------------------------------------------------------*/

extern  unsigned long far VideoID( void );

/*----------------------*/
/* Subsystem ID values: */
/*----------------------*/
#define VID_NONE        0
#define VID_MDA         1
#define VID_CGA         2
#define VID_EGA         3
#define VID_MCGA        4
#define VID_VGA         5
#define VID_HERC        0x80
#define VID_HERCPLUS    0x81
#define VID_HERCINCOLOR 0x82

/* Monitor display types */

#define MON_NONE        0
#define MON             1
#define MON_CGA         2
#define MON_EGA         3
#define MON_VGA_MONO    4
#define MON_VGA_COLOR   5



